
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>[转贴]dbcached──“分布式 key-value 数据库内存缓存系统” / iVAN</title>

    <meta name="description" content="[转贴]dbcached──“分布式 key-value 数据库内存缓存系统” 原文:http://blog.s135.com/post/329/ 前言:dbcached 1.0 beta* 在 Memcached 1.2.4 的基础上编写而成,也是我的第一个开源C项目.编写 dbcached 的目的是为了最大限度的发挥 Memcached 内存缓存的优势,便捷地维护 Memcached 服务器节点哈希列表,智能地支持 Memcached 故障转移,同时保证数据的持久化存储. dbcached 协议:New BSD License 作者:张宴 网址:http://code.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">[转贴]dbcached──“分布式 key-value 数据库内存缓存系统”</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>原文:<a href="http://blog.s135.com/post/329/" rel="external nofollow noreferrer">http://blog.s135.com/post/329/</a></p>
<p>前言：dbcached 1.0 beta* 在 Memcached 1.2.4 的基础上编写而成，也是我的第一个开源C项目。编写 dbcached 的目的是为了最大限度的发挥 Memcached 内存缓存的优势，便捷地维护 Memcached 服务器节点哈希列表，智能地支持 Memcached 故障转移，同时保证数据的持久化存储。</p>
<p>　　dbcached</p>
<p>　　协议：<a href="http://www.opensource.org/licenses/bsd-license.php" rel="external nofollow noreferrer">New BSD License</a> <br />　　作者：张宴<br />　　网址：<a href="http://code.google.com/p/dbcached/" rel="external nofollow noreferrer">http://code.google.com/p/dbcached/</a></p>
<p>　　<strong>dbcached 是什么?</strong></p>
<p>　　● dbcached 是一款基于 Memcached 和 NMDB 的分布式 key-value 数据库内存缓存系统。</p>
<p>　　● <strong>dbcached = Memcached + 持久化存储管理器 + NMDB 客户端接口</strong></p>
<p>　　● Memcached 是一款高性能的，分布式的内存对象缓存系统，用于在动态应用中减少数据库负载，提升访问速度。</p>
<p>　　● NMDB 是一款多协议网络数据库(dbm类)管理器，它由内存缓存和磁盘存储两部分构成，使用 QDBM 或 Berkeley DB 作为后端数据库。</p>
<p>　　● QDBM 是一个管理数据库的例程库，它参照 GDBM 为了下述三点而被开发：更高的处理速度，更小的数据库文件大小，和更简单的API。QDBM 读写速度比 Berkeley DB 要快，详细速度比较见《<a href="http://qdbm.sourceforge.net/benchmark.pdf" rel="external nofollow noreferrer">Report of Benchmark Test</a>》。</p>
<p>　　<a href="http://code.google.com/p/dbcached/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9hdHRhY2htZW50LzIwMDgwMi9kYmNhY2hlZC5naWY=.jpg"></a></p>
<p>　　<strong>Memcached 和 dbcached 在功能上一样吗?</strong></p>
<p>　　● 兼容：Memcached 能做的，dbcached 都能做。除此之外，dbcached 还将“Memcached、持久化存储管理器、NMDB 客户端接口”在一个程序中结合起来，对任何原有 Memcached 客户端来讲，dbcached 仍旧是个 Memcached 内存对象缓存系统，但是，它的数据可以持久存储到本机或其它服务器上的 QDBM 或 Berkeley DB 数据库中。</p>
<p>　　● 性能：前端 dbcached 的并发处理能力跟 Memcached 相同；后端 NMDB 跟 Memcached 一样，采用了libevent 进行网络IO处理，拥有自己的内存缓存机制，性能不相上下。</p>
<p>　　● 写入：当“dbcached 的 Memcached 部分”接收到一个 set(add/replace/...) 请求并储存 key-value 数据到内存中后，“dbcached 持久化存储管理器”能够将 key-value 数据通过“NMDB 客户端接口”保存到 QDBM 或 Berkeley DB 数据库中。</p>
<p>　　● 速度：如果加上“-z”参数，采用 UDP 协议“只发送不接收”模式将 set(add/replace/...) 命令写入的数据传递给 NMDB 服务器端，对 Memcache 客户端写速度的影响几乎可以忽略不计。在千兆网卡、同一交换机下服务器之间的 UDP 传输丢包率微乎其微。在命中的情况下，读取数据的速度跟普通的 Memcached 无差别，速度一样快。</p>
<p>　　● 读取：当“dbcached 的 Memcached 部分”接收到一个 get(incr/decr/...) 请求后，如果“dbcached 的 Memcached 部分”查询自身的内存缓存未命中，则“dbcached 持久化存储管理器”会通过“NMDB 客户端接口”从 QDBM 或 Berkeley DB 数据库中取出数据，返回给用户，然后储存到 Memcached 内存中。如果有用户再次请求这个 key，则会直接从 Memcached 内存中返回 Value 值。</p>
<p>　　● 持久：使用 dbcached，不用担心 Memcached 服务器死机、重启而导致数据丢失。</p>
<p>　　● 变更：使用 dbcached，即使因为故障转移，添加、减少 Memcached 服务器节点而破坏了“key 信息”与对应“Memcached 服务器”的映射关系也不怕。</p>
<p>　　● 分布：dbcached 和 NMDB 既可以安装在同一台服务器上，也可以安装在不同的服务器上，多台 dbcached 服务器可以对应一台 NMDB 服务器。</p>
<p>　　● 特长：dbcached 对于“读”大于“写”的应用尤其适用。</p>
<p>　　<strong>1. dbcached</strong></p>
<p>　　<strong>Installation (安装)</strong></p>
<p>引用</p>
<p>wget <a href="http://www.monkey.org/~provos/libevent-1.3e.tar.gz" rel="external nofollow noreferrer">http://www.monkey.org/~provos/libevent-1.3e.tar.gz</a><br />tar zxvf libevent-1.3e.tar.gz<br />cd libevent-1.3e/<br />./configure --prefix=/usr<br />make &amp;&amp; make install<br />cd ../</p>
<p>wget <a href="http://dbcached.googlecode.com/files/dbcached-1.0.beta2.tar.gz" rel="external nofollow noreferrer">http://dbcached.googlecode.com/files/dbcached-1.0.beta2.tar.gz</a><br />tar zxvf dbcached-1.0.beta2.tar.gz<br />cd dbcached-1.0.beta2/<br />./configure --prefix=/usr/local/dbcached --with-libevent=/usr<br />make &amp;&amp; make install<br />cd ../</p>
<p>　　<strong>Run as a daemon (作为守护进程运行)</strong></p>
<p>引用</p>
<p>/usr/local/dbcached/bin/memcached -d -m 256 -p 11211 -c 51200 -u nobody -x 192.168.0.2 -y 26010 -z 26010</p>
<p>　　● -x nmdb 服务器的域名或者IP地址，推荐使用IP地址</p>
<p>　　● -y &lt;端口号&gt; nmdb 服务器的TCP端口号 (默认: 26010) 支持 set/delete/... 等写命令 和 get 等读命令</p>
<p>　　● -z &lt;端口号&gt; nmdb 服务器的UDP端口号 (默认: 26010) 只支持 get 等都命令, 当使用 -z 参数时，将使用 UDP 协议代替 TCP 协议执行 set 操作，执行 get 操作时仍然使用 TCP 协议。强烈推荐加上 -z 参数。 <br />　　● 其他参数跟 memcached 1.2.4 完全一样，就不再详细说明。</p>
<p>　　● 如果想让 dbcached 通过 NMDB 保存数据时采用 TCP 协议，去掉 -z 参数即可，例如：(除非因防火墙、NAT穿透等问题导致 UDP 协议不可用，否则不建议使用 TCP 协议)</p>
<p>引用</p>
<p>/usr/local/dbcached/bin/memcached -d -m 256 -p 11211 -c 51200 -u nobody -x 192.168.0.2 -y 26010</p>
<p>　　● 如果想让 dbcached 作为普通的 Memcached 运行，去掉 -x、-y、-z 参数即可，例如：</p>
<p>引用</p>
<p>/usr/local/dbcached/bin/memcached -d -m 256 -p 11211 -c 51200 -u nobody</p>
<p>　　<strong>2. QDBM &amp; NMDB</strong></p>
<p>　　QDBM 和 NMDB 均为原版，可以从它们的官方网站下载最新版本。</p>
<p>　　<strong>QDBM Installation (安装)</strong></p>
<p>引用</p>
<p>wget <a href="http://qdbm.sourceforge.net/qdbm-1.8.77.tar.gz" rel="external nofollow noreferrer">http://qdbm.sourceforge.net/qdbm-1.8.77.tar.gz</a><br />tar zxvf qdbm-1.8.77.tar.gz<br />cd qdbm-1.8.77/<br />./configure --prefix=/usr<br />make<br />make install<br />cd ../</p>
<p>　　<strong>NMDB Installation (安装)</strong></p>
<p>引用</p>
<p>wget <a href="http://www.monkey.org/~provos/libevent-1.3e.tar.gz" rel="external nofollow noreferrer">http://www.monkey.org/~provos/libevent-1.3e.tar.gz</a><br />tar zxvf libevent-1.3e.tar.gz<br />cd libevent-1.3e/<br />./configure --prefix=/usr<br />make &amp;&amp; make install<br />cd ../</p>
<p>wget <a href="http://auriga.wearlab.de/~alb/nmdb/files/0.21/nmdb-0.21.tar.gz" rel="external nofollow noreferrer">http://auriga.wearlab.de/~alb/nmdb/files/0.21/nmdb-0.21.tar.gz</a><br />tar zxvf nmdb-0.21.tar.gz<br />cd nmdb-0.21/<br />make BACKEND=qdbm ENABLE_TIPC=0 ENABLE_SCTP=0 install<br />cd ../</p>
<p>　　<strong>Run as a daemon (作为守护进程运行)</strong></p>
<p>引用</p>
<p>/usr/local/bin/nmdb -d /var/dbcached.db -t 26010 -T 192.168.0.2 -u 26010 -U 192.168.0.2 -c 1024</p>
<p>　　● -d 数据库路径(这里使用比 Berkeley DB 更快的 QDBM 数据库)，例如 /var/dbcached.db</p>
<p>　　● -t TCP 监听端口 (默认：26010)</p>
<p>　　● -T TCP 监听地址 (默认：任何地址)</p>
<p>　　● -u UDP 监听端口 (默认：26010)</p>
<p>　　● -U UDP 监听地址 (默认：任何地址)</p>
<p>　　● -c 最大的缓存对象数目，单位为千 (默认：128)</p>
<p>Tags: <a href="http://blog.s135.com/post/329/tags/linux/" rel="external nofollow noreferrer">linux</a> , <a href="http://blog.s135.com/post/329/tags/memcached/" rel="external nofollow noreferrer">memcached</a> , <a href="http://blog.s135.com/post/329/tags/memcache/" rel="external nofollow noreferrer">memcache</a> , <a href="http://blog.s135.com/post/329/tags/dbcached/" rel="external nofollow noreferrer">dbcached</a> , <a href="http://blog.s135.com/post/329/tags/nmdb/" rel="external nofollow noreferrer">nmdb</a> , <a href="http://blog.s135.com/post/329/tags/qdbm/" rel="external nofollow noreferrer">qdbm</a> , <a href="http://blog.s135.com/post/329/tags/memcachedb/" rel="external nofollow noreferrer">memcachedb</a> , <a href="http://blog.s135.com/post/329/tags/php/" rel="external nofollow noreferrer">php</a></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ180NGRlYTQ5YmI1ODYxODRlMTU0NjhkYzg0MWE0NWQwNC5naWY=.jpg"> <a href="http://blog.s135.com/post/329/category/8/" rel="external nofollow noreferrer">技术大类</a> » <a href="http://blog.s135.com/post/329/category/13/" rel="external nofollow noreferrer">Cache与存储</a> | <a href="http://blog.s135.com/post/329/post/329/#reply" rel="external nofollow noreferrer">评论(20)</a> | <a href="http://www.cnblogs.com/yjmyzz/admin/javascript:%20void(0);" rel="external nofollow noreferrer">引用(0)</a> | <a href="http://blog.s135.com/post/329/post/329/" rel="external nofollow noreferrer">阅读(10459)</a><br />
<br />
<strong>引用地址：</strong> <br /><strong>注意：</strong> 该地址仅在今日23:59:59之前有效</p>
<p>乐百氏<br />
<br />2008-2-19 10:03</p>
<p>赫赫，有意思，</p>
<p>outrace<br />
<br />2008-2-19 10:25</p>
<p>麻烦问一下：<br />跟Memcachedb 项目有啥差异？</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-19 16:52</p>
<p>dbcached 与新浪的另一开源产品 Memcachedb 一样，都支持 Memcached 协议，具有持久化存储功能，但两者有不同之处：</p>
<p>1、故障转移</p>
<p>先引用 memcached 官方网站和 PHP 手册中的两段话：<br /><a href="http://www.danga.com/memcached/" rel="external nofollow noreferrer">http://www.danga.com/memcached/</a><br />If a host goes down, the API re-maps that dead host's requests onto the servers that are available.</p>
<p><a href="http://cn.php.net/manual/zh/function.Memcache-addServer.php" rel="external nofollow noreferrer">http://cn.php.net/manual/zh/function.Memcache-addServer.php</a><br />Failover may occur at any stage in any of the methods, as long as other servers are available the request the user won't notice. Any kind of socket or Memcached server level errors (except out-of-memory) may trigger the failover. Normal client errors such as adding an existing key will not trigger a failover.</p>
<p>再以一个例子来说明：<br />&lt;?php<br />/* OO API */<br />$memcache = new Memcache;<br />$memcache-&gt;addServer('192.168.0.5', 11211);<br />$memcache-&gt;addServer('192.168.0.6', 11211);<br />$memcache-&gt;addServer('192.168.0.7', 11211);<br />$memcache-&gt;addServer('192.168.0.8', 11211);<br />?&gt;</p>
<p>       当 Memcache 客户端使用 addServer 服务器池时，是根据“crc32(key) % current_server_num”哈希算法将key哈希到不同的服务器的，PHP、C和python的客户端都是如此的算法。</p>
<p>       Memcache 客户端的 addserver 具有故障转移机制，当 addserver 了4台 Memcached 服务器，而其中一台宕机了，那么 current_server_num 会由原先的4变成3，这时就会重新哈希了。</p>
<p>       举个例子，假设在4台服务器都正常的情况下，key 值 aaa 被哈希到服务器 192.168.0.5 上，如果这时 192.168.0.7 宕机了，key 值 aaa 就可能就会被重新哈希到服务器 192.168.0.6 上，这时就找不到数据了。当然，假设 key 值 aaa 两次哈希的值是一样，它将仍被哈希到 192.168.0.5 上，但是不管怎样，都会导致一部分数据丢失。</p>
<p>       Memcachedb 可以保证数据的持久化存储，但目前还没有解决 Memcache 服务器池故障转移导致的数据丢失。而 dbcached 可以，它在未命中时会请求后端的 NMDB 取回数据。在接下来的版本中，dbcached 后端的 NMDB 将设计为两台，进行互备，届时无论前端 dbcached 中的某几台挂了还是后端 NMDB 中的一台挂了，数据都不会丢失。</p>
<p>2、设计方向</p>
<p>       dbcached 和 Memcachedb 的设计方向不同，dbcached 的设计方向是发挥 Memcached 的内存缓存性能优势，使之成为一个具有“故障转移”、“数据持久化存储”、“多服务器同时读写”的高并发内存缓存系统，它是围绕 Memcached 进行开发的。而 Memcachedb 只使用了 Memcached 的协议和网络层，抛弃了 Memcached 的内存管理部分，使用 Berkeley DB 数据库自身的缓存来实现，是围绕 Berkeley DB 进行开发的，目前支持类似 MySQL 主辅库同步的方式实现读写分离，支持“主服务器可读写、辅助服务器只读”模式。</p>
<p><a href="http://blog.s135.com/post/329/user/73/" rel="external nofollow noreferrer">powerv</a><br />
<br />2008-2-20 02:25</p>
<p>因为EN文不好，一直没搞懂MMCACHE这些怎样应用。是否直接装上就可以产生作用，而不需要程序或者MYSQL做设置调整。谢谢</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-20 08:16</p>
<p>Truck MMCache 即 eAccelerator 的前身，推荐安装 eAccelerator，装上就可以起到加速PHP的作用了。</p>
<p>dd<br />
<br />2008-2-20 15:08</p>
<p>这个程序将 php等程序从mysql 等 数据库读取的数据 存到到<br />QDBM 或 Berkeley DB  这样的数据库中  <br />当客户端在Memcached  中没有知道到请求的的数据 然后到 QDBM 或 Berkeley DB  中查找</p>
<p>这样和直接从数据库中读取 区别很大吗</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-20 18:53</p>
<p>区别在于并发性能和速度：</p>
<p>1、并发：千万级数据查询，MySQL的速度比较慢，如果并发连接达到300以上，MySQL基本上就崩溃了。就算是只有几万条数据的定长表，撑死也就能达到3000的并发连接。<br />2、速度：往QDBM中写入100万条记录，只需耗费1～4秒，Berkeley DB 只需3～11秒，取平均值5秒计算，每秒可以插入20万条记录，而读取速度还要稍快一点，对于千万级的数据处理性能没问题。而MySQL每秒只能插入50～1000条数据。</p>
<p>但是 QDBM 或 Berkeley DB 等嵌入式数据库不是关系型数据库，不能进行SQL语句查询、排序，只能根据key值写入或者读取其对应的Value信息。</p>
<p><a href="http://blog.s135.com/post/329/user/80/" rel="external nofollow noreferrer">代码罐头</a><br />
<br />2008-2-20 19:41</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9pbWFnZXMvYXZhdGFycy8yLmpwZw==.jpg"><br />
<br />如果要做通用性的持久读cache<br />master-slave模式就可以了<br />考虑到主从模式.写操作的时候从服务器的负载以及网络负载问题<br />可以在应用上做数据库的垂直分割.<br />memcache本来就是作为临时cache存在的.<br />如果修改成了持久性的数据cache层.<br />那么我个人还是觉得数据库用主从模式就可以解决了.<br />这样对应用层的要求也会比较小.<br />因为MEMCACHE对应用层的改动太大.要求的工作也很多.<br />至于千万级的数据查询.如果你把这么多数量的内容都作为key来做memcache<br />这个性能一样不会高到哪里去的.<br />memcache只有对于最最常用的东西做cache才有效的.</p>
<p>至于插入问题.memcache只是缓冲层<br />他的插入也只是临时性的<br />虽然memcache可以将操作速度大大提高<br />但是最终数据仍旧是要跑到主数据库保存的<br />由于木桶理论.你的这个操作再快,也无法解决整体结构中写操作的速度<br />如果用了事务那就更加慢了.<br />除非你把写操作也cache下来.然后后台再把memcache里面的内容写到mysql里面,而不是由应用层来做这个工作.否则memcache写性能在强也于事无补的.</p>
<p>一些拙见.大家探讨.</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-20 20:51</p>
<p>对于千万级的数据，Memcached是很快的，因为它是根据key，确定value在内存中的位置，从而取出数据，性能跟数据条数无关。不然 Facebook 也不会弄400台 16GB 的机器来跑 memcached。</p>
<p>而QDBM、BDB是哈希数据库，BDB的最大容量支持256TB，比MySQL的SELECT要快的多。</p>
<p>对于“Memcache 客户端”而言，dbcached 的写操作是很快的。<br />普通 Memcached 接收到set请求，将数据写入内存。<br />dbcached 接收到set请求，将数据写入内存，并将数据通过UDP协议发送给NMDB。通过UDP协议发送给NMDB几乎不会花费多少时间，因为dbcached将数据发送出就结束会话了，它不会管NMDB是否接收到，也不会管NMDB的返回信息。NMDB接收到信息，会用队列去写QDBM数据库的，写数据库的速度慢了些也没关系，不影响用户服务。</p>
<p>MySQL专用于做复杂的关系查询，dbcached专用于做简单的高并发查询。</p>
<p>dbcached的目的就是为了避免Memcached挂掉重启后，从后端的MySQL大量读取数据。在我们的应用中，一台Memcached的并发连接最大跑到8000多，只要倒一台，这部分并发量去访问后端的MySQL服务器重新取回数据，都是无法承受的，因为我们没有这么多的MySQL服务器。</p>
<p><a href="http://blog.s135.com/post/329/user/80/" rel="external nofollow noreferrer">代码罐头</a> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS90ZW1wbGF0ZS9SdWlQYWkvaW1hZ2VzL2VtYWlsLmdpZg==.jpg"><br />
<br />2008-2-20 20:16</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9pbWFnZXMvYXZhdGFycy8yLmpwZw==.jpg"><br />
<br />张兄的项目.恕我胡乱揣摩.最终目的慢慢转化后<br />变成解决数据库的高可用性和负载均衡问题.<br />简言之就是数据库的虚拟化.<br />memcache本身只是作为cache存在<br />cache的目的纯粹是为了慢速设备和快速设备之间做缓冲<br />而持久性和可靠性并不计在内(所有的cache在掉电后都允许数据损失,而且即便cache数据不可靠.也没有关系.因为cache不是最终数据保存的地方,cache允许数据存在时差或者误差)<br />memcache之所以存在许多不足.<br />不是由于它没有持久数据或者它的可靠性不足<br />而是由于它并非是从数据库存取数据<br />需要靠应用层主动对缓冲数据进行操作.<br />memcache这种手动优化的方法<br />在程序小的时候不会有问题,一旦程序框架变大<br />就变成整个项目需要手动优化数据存取</p>
<p>解决数据库虚拟的方法在于<br />在应用层下面建立透明的代理层<br />mysqlproxy项目的概念是非常好的.<br />虚拟化了后端的数据库服务器之后<br />不论是HA,还是LB,都可以通过代理层进行透明的操作.<br />代理可以对执行的操作进行简单的分类,比如读,还是写,对哪个库,哪个表操作.<br />代理层通过分析后,可以将实际的操作交由不同的后端数据库来做.<br />这样不论是读写分离,还是数据库垂直,水平分割,或者高可用性.<br />都是通过一个透明层来进行虚拟化.</p>
<p>memcache只是在虚拟化途中的一个临时变通手段<br />如果张兄继续优化.最终可能会变成一个类似MySQL Proxy的东西<br />不论现在做的什么手段<br />最终大家需要的.应该是一个类似LVS的MYSQL虚拟机</p>
<p><a href="http://blog.s135.com/post/329/user/80/" rel="external nofollow noreferrer">代码罐头</a><br />
<br />2008-2-21 09:04</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9pbWFnZXMvYXZhdGFycy8yLmpwZw==.jpg"></p>
<p>引用</p>
<p>对于千万级的数据，Memcached是很快的，因为它是根据key，确定value在内存中的位置，从而取出数据，性能跟数据条数无关。不然 Facebook 也不会弄400台 16GB 的机器来跑 memcached。</p>
<p>和我猜想的用法很像.<br />memcache在这里其实类似于mysql的query cache<br />不过这样.可以完全抛弃memcache的固有做法<br />因为你的问题域减小了.不再是所有网页内容的cache.而是mysql select查询的cache.<br />而从应用层来自己做set.get.<br />我一直认为不是件很好的事情<br />分层就会逐渐模糊.</p>
<p>我建议dbcached做一个mysql-like的接口<br />将获取到的select query做hash,和hash table里面的比对<br />如果cache未命中,则发送到后端的mysql<br />cache命中,则直接返回内存中的内容<br />这样这个cache对于上层就是完全透明的.</p>
<p>乐百氏<br />
<br />2008-2-21 09:51</p>
<p>赫赫同意代码罐头</p>
<p>感觉这个dbcached和sina的memcachedb作用差不多。</p>
<p>dbcached的设计的和实际的出发点有些别离，感觉有些南辕北辙</p>
<p>Roast <a href="http://www.libing.name/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS90ZW1wbGF0ZS9SdWlQYWkvaW1hZ2VzL2hvbWVwYWdlLmdpZg==.jpg"></a><br />
<br />2008-2-21 11:03</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9pbWFnZXMvZW1vdC9ncmluLmdpZg==.jpg"><br />咋的不直接用QDBM了了？</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-21 11:46</p>
<p>直接用QDBM，dbcached和QDBM就必须放在一台服务器上，这样跟Memcachedb就没什么差别了。</p>
<p>dbcached 整个构架是：dbcached 这一层服务器只做缓存，后端 NMDB+QDBM 的一层为数据存储中心。这样就需要跨服务器读写QDBM，跨服务器就需要走网络协议，所以用了现成的开源工具 NMDB 去处理网络层。（其实后端用 Memcachedb 也是差不多的，以后可能会考虑支持）</p>
<p>目前前端的 dbcached 服务器倒了任何一台，都是没关系的，只要还有其他的 dbcached 服务器活着，在这段时间内用户的读写仍然正常，缓存中丢失的数据会请求后端的 NMDB 重新获取。</p>
<p>而后端的 NMDB + QDBM 目前只有一台，按照我的思路，在今后的 dbcached 版本，后端将增加到两台 NMDB + QDBM，dbcached 将接收到的set请求用UDP协议同时发送给两台 NMDB + QDBM（UDP只发送不接收，发出去就不等待了，多发一次也不影响效率），get请求未命中时先请求第一台 NMDB + QDBM，如果发现它挂了，会请求第二台 NMDB + QDBM，就有点类似本地DNS设置的主、辅服务器。</p>
<p>这样无论前端 dbcached 中的某几台挂了还是后端 NMDB 中的一台挂了，在这段时间内，用户的读写数据都不会受到影响。</p>
<p>sumdunk<br />
<br />2008-2-22 10:55</p>
<p>想问一下.如果单笔数据量很大.且有很复杂的关联性.dbcached会不会胜任.因为MEMCACHE似乎只是KEY-&gt;VALUE的存储,</p>
<p>举个例子,发一个文章,同时POST的 数据有很多,TITLE,CONTENT.DATE.等,.如果先进行DBCACHE,怎么进行保存,后端进行QDBM备份 时候,逻辑应该也会很复杂吧.</p>
<p><a href="http://blog.s135.com/post/329/user/2/" rel="external nofollow noreferrer">张宴</a> 回复于 2008-2-22 14:11</p>
<p>稍微复杂一点的可以用写入、读出数据来实现，以下这种方法是将数组存入一个key：<br />&lt;?php<br />$memcache = new Memcache;<br />$memcache-&gt;addServer('127.0.0.1', 11211);</p>
<p>$title_id = "id_123";<br />$key['title'] = "this is title";<br />$key['content'] = "this is content";<br />$key['date'] = "2008-02-22 13:14:23";</p>
<p>$memcache-&gt;set($title_id, $key);</p>
<p>echo "&lt;pre&gt;";<br />print_r($memcache-&gt;get($title_id));<br />echo "&lt;/pre&gt;";<br />?&gt;<br />显示：<br />Array<br />(<br />   [title] =&gt; this is title<br />   [content] =&gt; this is content<br />   [date] =&gt; 2008-02-22 13:14:23<br />)</p>
<p>还有一种方法就是存入多个key，取的时候可以取其中的一部分：<br />&lt;?php<br />$memcache = new Memcache;<br />$memcache-&gt;addServer('127.0.0.1', 11211);</p>
<p>$title_id = "id_123";<br />$memcache-&gt;set('title_'.$title_id, 'this is title');<br />$memcache-&gt;set('content_'.$title_id, 'this is content');<br />$memcache-&gt;set('date_'.$title_id, '2008-02-22 13:14:23');</p>
<p>$keys = array();<br />$keys[]= 'title_'.$title_id;<br />$keys[]= 'content_'.$title_id;</p>
<p>echo "&lt;pre&gt;";<br />print_r($memcache-&gt;get($keys));<br />echo "&lt;/pre&gt;";<br />?&gt;<br />显示：<br />Array<br />(<br />   [title_id_123] =&gt; this is title<br />   [content_id_123] =&gt; this is content<br />)</p>
<p>再复杂的就要用关系型数据库了。</p>
<p>非狐外传<br />
<br />2008-2-22 16:55</p>
<p>很好，支持这个东西。有机会尝试一下</p>
<p><a href="http://blog.s135.com/post/329/user/80/" rel="external nofollow noreferrer">代码罐头</a><br />
<br />2008-2-22 17:35</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS9pbWFnZXMvYXZhdGFycy8yLmpwZw==.jpg"></p>
<p>引用</p>
<p>想问一下.如果单笔数据量很大.且有很复杂的关联性.dbcached会不会胜任.因为MEMCACHE似乎只是KEY-&gt;VALUE的存储,</p>
<p>举个例子,发一个文章,同时POST的 数据有很多,TITLE,CONTENT.DATE.等,.如果先进行DBCACHE,怎么进行保存,后端进行QDBM备份 时候,逻辑应该也会很复杂吧.</p>
<p>呵呵.这个问题恰恰就是memcache的本质性的弊端了<br />因为他要求开发人员手动对缓冲内容进行处理.<br />开发人员需要预判缓冲可能发生的最高的情况.<br />如果实际状况和预判的不同<br />则命中率低下的开销会大过开发难度的提升.<br />而实际情况中,对于缓冲内容是会根据不同用户的不同时期的需求发生改变的.</p>
<p>而针对数据库的缓冲层(以下简称mysqlcache).我觉得和memcache的工作机理相同,但是还有很多本质区别.<br />其差别基本上等同于xcache这类的op cache和memcache这种内容cache<br />1.mysql缓冲层对于上层是透明的.程序员应该和操作mysql数据库一样去操作mysqlcache,而memcache则是由开发人员来决定哪些内容放入cache.上层是需要针对memcache来做操作的.<br />2.mysqlcache可以和其他的虚拟层一样,通过本身的策略来决定cache的保留与丢弃,这些用户只需要在配置文件内修改,同样保证了透明性,而memcache需要在应用层内决定保留哪些,丢弃哪些,如果不对已经缓冲资源进行丢弃.势必导致超出memcache服务器的内存容量,导致swap,引起性能下降.<br />3.mysqlcache是对整条mysql语句进行hash,而memcache是对某特定内容进行hash,memcache从某种程度来说(mysql使用过多如selecte *等未优化语句)占用内存更小<br />4.mysqlcache可以轻易加入负载均衡或者高可用性功能,由于其是代理层,可以对后端的mysql状态或者查询进行分发,memcache其实是和mysql平行的一个模块.是在应用层使用的缓冲技术,从理论上来说如果没有独立的mysql负载均衡或者HA措施,memcache对这两者是无能为力的.因为memcache的数据是由应用层取出并放入,而不是它本身直接去操作数据库的.</p>
<p>对mysql的透明代理应用感兴趣的.可以看看mysql proxy项目,不过目前还不是stable的.所以在性能以及稳定性方面还没有确切的保证.但是其可能的用途是非常好的.<br />1.mysql的HA.这点已经做到了<br />2.mysql的负载均衡.这点也完成了<br />3.mysql的读写分离.这点也完成了<br />4.mysql的数据表的纵向分割,这点我没有实验是否可行,但是理论上是可以的.我们可以通过分析获取到的查询所针对的表名,然后将不同表的查询分发至不同的mysql后端<br />5.mysql的数据横向分割,理论上也是可行的,但是难度很高.可以分析where子条件中来语句属于哪一段,从而分发到不同的后端.但是开销很大.我很怀疑这样做了以后.mysql proxy本身会变成瓶颈</p>
<p>Robin<br />
<br />2008-3-20 14:50</p>
<p>你们说的差不多,偏重点不一样</p>
<p>tim<br />
<br />2008-4-23 17:35</p>
<p>如果是memcached,在分配的内存用完后,默认情况下,后面加入的items会把之前加入的尚在生命期内的项目挤出去,如果是这种情况,dbcached也是同样的处理方式吗?挤出去之后,存在QDBM的数据是什么一个状态?也会被挤掉?</p>
<p>我目前的情况是用memcache作session数据处理,后端用了mysql来做持久,如果改用dbcached有风险吗?</p>
<p>空格<br />
<br />2008-4-24 00:32</p>
<p>由memcached层向NMDB发送写请求使用UDP的话，这样虽然速度有保证，但是由于UDP连接的特性决定会有（虽然概率不大）写入失败的情况，难道这个时候memcached中有这条数据，而你的持久层中没这条数据？也就是说，用户发的内容，可能这会有，一旦你这台memcached断电或者这条数据被新数据挤掉以后，也就不能恢复了，这难道是运营策略？</p>
<p><a href="http://blog.s135.com/post/329/user/73/" rel="external nofollow noreferrer">powerv</a><br />
<br />2008-6-19 12:55</p>
<p>今天又重新回来看了这篇文章，memcached 已经有新的版本了1.2.5。<br />看了上面的讨论，又搜索了一下其他资料。希望大家能指正一下我的理解：<br />1，mysql proxy 并不会缓存数据，而只是分离数据，然后中转到mysql <br />2，dbcached 是通过用户端的请求数据临时存到比mysql更快的数据库，然后通过跨服务器读写QDBM，把数据转到mysql里面去。用户先在比mysql更快中的服务器中读缓存数据。<br />上面的理解是否错误？<br />另外问个问题。dbcached全挂掉的话，会导致数据丢失吗？</p>
<p>Vermin<br />
<br />2008-7-3 16:32</p>
<p>最近改在memcache，打算用mysql udf+triggers通知memcached更新数据，就完全不从数据库中读取，memcache的数据改为存放在mmap中，这样应该能好一点：）</p>
<p>junney <a href="http://www.junney.cn/" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS90ZW1wbGF0ZS9SdWlQYWkvaW1hZ2VzL2hvbWVwYWdlLmdpZg==.jpg"></a><br />
<br />2008-11-9 15:45</p>
<p>对于楼上兄弟说的，在应用上的适合范围很小，因为mysql本身不支持array或者object等复杂的数据类型，没办法实现将多行数据缓存到memcached中去。因为udf毕竟作用于单个列数据的一个函数。</p>
<p>呵呵<br />
<br />2008-12-4 15:06</p>
<p>这个应用怎么支持事务的?谢谢</p>
<p>sarin <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvZy5zMTM1LmNvbS9wb3N0LzMyOS90ZW1wbGF0ZS9SdWlQYWkvaW1hZ2VzL2VtYWlsLmdpZg==.jpg"><br />
<br />2009-2-27 19:45</p>
<p>测试了一下,主要有以下两个问题.</p>
<p>1.不支持git上的最新的nmdb,这个估计是nmdb的问题.<br />但是最新的nmdb已经支持tokyocabinet,如果dbcached能支持最新的nmdb,那就最好了<br />2.不支持memcache的过期.</p>
<p>不支持过期会极大的限制dbcached的应用范围</p>
<p>很期待支持双机的dbcached</p>
<p> </p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 21:02:09</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/mysql/" title="mysql">mysql</a>, <a href="https://www.iamivan.net/tag/%e5%88%86%e5%b8%83%e5%bc%8f/" title="分布式">分布式</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e8%b4%9f%e8%bd%bd%e5%9d%87%e8%a1%a1/" title="负载均衡">负载均衡</a>, <a href="https://www.iamivan.net/tag/cache/" title="Cache">Cache</a>, <a href="https://www.iamivan.net/tag/memcached/" title="memcached">memcached</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>[转贴]dbcached──“分布式 key-value 数据库内存缓存系统”的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bo71PXb.html" rel="bookmark">内存缓存LruCache实现原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自己项目中一直都是用的开源的xUtils框架,包括 BitmapUtils.DbUtils.ViewUtils和HttpUtils四大模块,这四大模块都是项目中比较常用的.最近决定研究一下 xUtils的源码,用了这么久总得知道它的实现原理吧.我是先从先从BitmapUtils模块开始的.BitmapUtils和大多数图片加载框架一 样,都是基于内存-文件-网络三级缓存.也就是加载图片的时候首先从内存缓存中取,如果没有再从文件缓存中取,如果文件缓存没有取到,就从网络下载图片并 且加入内存和文件缓			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2yGZrz.html" rel="bookmark">关于使用key&sol;value数据库redis和TTSERVER的心得体会</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇文章是对使用key/value数据库redis和TTSERVER的心得体会进行了详细的分析介绍,需要的朋友参考下   先说redisredis是一个类似memcached的key/value存储系统,它支持存储的 value类型相对较多,包括string(字符串). list(链表).set(集合)和zset(有序集合).在此基础上,redis支持各种不同方式的排序.与memcached一样,为了保证效率,数 据都是缓存在内存中.区别的是redis会周期性的把更新的数据写入磁盘或者把修改操作			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkGk87p.html" rel="bookmark">Memcached分布式内存对象缓存系统简单的使用过程分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				风信网(ithov.com)原创文章:Memcached是一套分布式内存对象缓存系统,用于在动态系统中减少数据库负载,进而提升系统性能.Memcached在很多时候都作为数据库的前端cache使用,因为它比数据库少了很多SQL解析.磁盘操作等开销,而且使用内存来管理数据,所以它可以提供比直接读取数据库更好的性能.另外,Memcached也经常作为服务器之间数据共享的存储媒介.学习完本章,相信读者能够对Memcached有一个全面的了解,使构建一套属于自己的分布式内存对象缓存系统变成很简单的事情.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qMqeQkM.html" rel="bookmark">建立对象数据库-内存映射范式，需要中间层容器的支持</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对象|数据|数据库|中间层 在&lt;设想使用XML和关系数据库形成一个对象数据库&gt;一文中,已经阐述了关系数据库和对象数据库的主要区别:对外键的使用是通过直接记录,还是遍历外键子表来获得.而这里,是面对另一个重要的区别:如何释放对象的资源.对于对象数据库而言,它等同于是一批直接存于数据库中的串行化对象,它的实际存储形式到底是不是按关系结构存储并不是最重要的,重要的是调用程序读入内存的就是一个对象,而不是游标映射:这样,使用对象数据库就必须存在着一个如何清除用完的对象资源的问题:同时由于对象数据库必然			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zewYVM.html" rel="bookmark">用ado&period;net进行分布式程序设计更新数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ado|程序|分布式|设计|数据|数据库 提供一个数据服务类,调用GetDataSet就得到需要的DataSet,然后在用户界面进行修改,最后调用SaveDate就可以把未定的更改保存到数据库.using System;using System.Data ;using System.Data.SqlClient ; namespace AsterDnet.DataBind{    /// &lt;summary&gt;    /// Summary description for GetData.    			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBenOM.html" rel="bookmark">android-Android数据库内存溢出的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android数据库内存溢出的问题 请问Android编译时出现这个问题:out of memory on a 1900-byte allocation怎么解决? 解决方案 看下图片是不是过大http://blog.csdn.net/lizhenmingdirk/article/details/30490789 解决方案二: 是不是你用数据库存储文件了?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boL4DEM.html" rel="bookmark">分布式列式数据库 IndexR 开源啦！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2017新年好!IndexR开源啦! IndexR是一个专注于大数据实时分析的分布式列式数据库,它基于HDFS,能快速分析海量结构化数据,支持实时导入并且查询秒级延迟,特别适合ad-hoc场景下的OLAP查询. IndexR具体实现参考并使用了众多优秀的开源项目,比如 Infobright,Hbase,Druid,Drill 等,与Hadoop生态圈深度结合.目前它主要通过作为Apache Hive和Apache Drill的插件来使用. IndexR已经正式开源.我们希望通过这种方式为开源社区			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBGa7kM.html" rel="bookmark">Memcached分布式内存对象缓存系统的性能监控</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				风信网(ithov.com)原创文章:本文将从三个方面向你介绍Memcached分布式内存对象缓存系统的管理与http://www.aliyun.com/zixun/aggregation/14216.html&quot;&gt;性能监控,主要的内容涉如何管理Memcached,如何监控Memcached及随着Memcached应用不断衍生出来的各变种产品的介绍. 如何管理Memcached 1．通过Memcached的监听端口进行管理 Memcached的管理相对比较容易,通过命令行登录到Memcach			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MryXw6b.html" rel="bookmark">可扩展分布式关系型云数据库方案</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可扩展分布式关系型云数据库方案 王献美 吴迪冲 朱泽飞 李仁旺 为满足云数据库高并发 高可扩展和高可用性的需求在分析各种关系型和 数 据 库 的 基 础上借鉴关系型数据的便捷性与可扩展性提出了一种可扩展性的关系型云数据库方案该方案提出了全新的系统架构 数据库读写流程数据合并流程数据模型和数据结构与存储并对其系统架构理论存在瓶颈进行分析最后对数据一致性可用性和线上运行性能进行分析结果表明此方案可行. 关键词:云数据库 可拓展性 海量数据 存储分布式事务 可扩展分布式关系型云数据库方案			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzV0DYM.html" rel="bookmark" class="title">Photoshop打造另类风格的照片色调</a>
					<div>
						先看效果对比. 1.首先打开2幅素材图片. 2.将纹理拖入人物图片中,图层模式正片叠底. 3.添加蒙版,用黑色笔刷涂抹,得到下图效果. 4.打开一幅图片素材,拖入文档中. 5.Ctrl+T旋转一定角度 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMroW1p.html" rel="bookmark" class="title">巧用Photoshop&OpenCurlyDoubleQuote;3D变换&rdquo;滤镜绘制一枝铅笔</a>
					<div>
						滤镜 众所周知Photoshop是一个平面设计软件,但是通过其&quot;3D变换&quot;滤镜也可以创建一些简单的3D效果.&quot;3D变换&quot;滤镜提供了&quot;长方体&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9VBVp.html" rel="bookmark" class="title">selenium-webdriver&lpar;python&rpar; &lpar;十&rpar; 如何处理下拉框</a>
					<div>
						本节重点 处理下拉框 switch_to_alert() accept() 下拉框是我们最常见的一种页面元素,对于一般的元素,我们只需要一次就定位,但下拉框里的内容需要进行两次定位,先定位到下拉框,再 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2pLN7Wb.html" rel="bookmark" class="title">Access 2007查询介绍</a>
					<div>
						查询是Access2007数据库处理和分析数据的工具,是在指定的(一个或多个)表中根据给定的条件从中筛选所需要的信息,供使用者查看.更改和分析使用. 查询是Access2007数据库的一个重要对象,通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7Ra7b.html" rel="bookmark" class="title">CPU超频导致3D游戏频繁死机</a>
					<div>
						问:本人的计算机采用了P4赛扬1．7GHz CPU,杂牌GeForce 2 MX400显卡(显示核心和显存都进行了小幅度超频),运行Office等软件正常,为什么运行&lt;重返德军总部&gt;等3D ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7drqb.html" rel="bookmark" class="title">java隐藏实施过程</a>
					<div>
						&quot;进行面向对象的设计时,一项基本的考虑是:如何将发生变化的东西与保持不变的东西分隔开.&quot; 这一点对于库来说是特别重要的.那个库的用户(客户程序员)必须能依赖自己使用的那一部分,并知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB27Y4b.html" rel="bookmark" class="title">Win8的好东西&OpenCurlyDoubleQuote;偷运&rdquo;到Win7上去</a>
					<div>
						随着Win8 RTM的正式完工,伴随我们多年的Windows 7终于要成为过去式.Metro化菜单.Ribbon用户界面.更专业的任务管理器.勾人口水的应用商店-[主题之家]看到在这套微软最新的操作系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxW4w0b.html" rel="bookmark" class="title">微信锁2&period;7新增应用图标更换</a>
					<div>
						  设置方法: 进行&quot;微信锁&quot;-菜单-设置-替换自身图标,里面提供三个可选伪装图标,根据各自所需选择吧! [微信锁]是一款免费的微信隐私保护软件.在生活中经常碰到女(男)朋友想玩你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwL3oWb.html" rel="bookmark" class="title">电脑语言栏不能用快捷键切换该怎么办？</a>
					<div>
						  按着电脑的语言切换键,怎么按语言的切换键都不能用,感觉很莫名其妙,怎么回事了呢?小编给你说说小编的经验 1.首先找到输入法,然后右击设置,如图所示 2.在弹出来的界面点击高级键设置,如图所示 3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZqX3b.html" rel="bookmark" class="title">视频文件格式</a>
					<div>
						本人最近在做一个android视频的项目.特意总结了常见的视频格式: m,rmvb,mpeg1-4 mov mtv dat wmv avi 3gp amv dmv    这类格式可是影像阵营中的一个大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6r00b.html" rel="bookmark" class="title">浏览器事件window&period;onload、o&hellip;</a>
					<div>
						原文地址:浏览器事件window.onload.onfocus.onblur.onscroll和resize作者:lilyxiao &lt;html&gt; &lt;head&gt; &lt;titl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrBr9M.html" rel="bookmark" class="title">javascript-请教 一下 像豆瓣FM那样的 注册框是怎么实现的呀</a>
					<div>
						问题描述 请教 一下 像豆瓣FM那样的 注册框是怎么实现的呀 点一下注册按钮, 然后除了注册框,其他的都变成背景了(颜色变灰, 不能点击) 解决方案 &lt;!DOCTYPE HTML&gt; jqu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7wvop.html" rel="bookmark" class="title">数据结构之自建算法库&mdash;&mdash;图及其存储结构（邻接矩阵、邻接表）</a>
					<div>
						本文是[数据结构基础系列(7):图]中第4课时[图的邻接矩阵存储结构及算法]和第5课时[图的邻接表存储结构及算法],并为后续内容的实践提供支持. 图的存储结构主要包括邻接矩阵和邻接表,本算法库提供存储 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPj6vp.html" rel="bookmark" class="title">源代码可以运行，自己写出不来</a>
					<div>
						问题描述 源代码可以运行,自己写出不来 using System; using System.Collections.Generic; using System.ComponentModel; usi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7oWAz.html" rel="bookmark" class="title">C&plus;&plus;的函数重载</a>
					<div>
						--每个现象后面都隐藏一个本质,关键在于我们是否去挖掘 写在前面: 函数重载的重要性不言而明,但是你知道C++中函数重载是如何实现的呢(虽然本文谈的是C++中函数重载的实现,但我想其它语言也是类似的) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE9KXz.html" rel="bookmark" class="title">光标跑偏 webvi&period;&period;&period;-WebView加载一个h5网址后</a>
					<div>
						问题描述 WebView加载一个h5网址后 WebView加载一个h5网址后登陆文本输入框无法定位光标,光标在输入框外面 解决方案 这个不属于Android范畴,这是JavaScript的问题					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKXq7b.html" rel="bookmark" class="title">精美UI界面欣赏&lbrack;10&rsqb;</a>
					<div>
						精美UI界面欣赏[10]  					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40BOrz.html" rel="bookmark" class="title">Database Login dialog popup when a crystal report project is x64</a>
					<div>
						问题描述 Icreatedac#winformproject,draganddrog&quot;CrystalReportViewer&quot;fromtoolboxtotheform,andint ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGE9LkM.html" rel="bookmark" class="title">张近东如何用高维打击战略赢得价格战</a>
					<div>
						直面阿里巴巴.腾讯,苏宁有了一个指向未来10年的全新构想:沃尔玛+亚马逊.看张近东如何用高维打击战略赢得这场黑暗森林战役. 今天是苏宁京东价格战的第一天.他们之间有必要殊死一战吗?本刊近日独家专访了张 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgmwAM.html" rel="bookmark" class="title">阅后即焚式社交聊天工具锐化接收者的专注度</a>
					<div>
						摘要: 阅后即焚式社交聊天工具锐化了接收者的专注度,保护了用户的隐私,因此也受到了越来越多用户的青睐.但是由于对用户所知甚少,又没有应用内购买或者订购服务,此类服务往往很 阅后即焚式社交聊天工具锐化了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwmemM.html" rel="bookmark" class="title">致电视巨头们：请放下战略，用心做好产品</a>
					<div>
						  我已经有些厌倦国内那些进军智能电视的厂商了. 动辄颠覆.秒杀.改变产业格局,到头来却变成一张张空头支票,产品糟糕至极. 且从硬件说起. 在今年3月某家青岛电视厂商发布了三款采用新屏幕技术的电视,该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QNWap.html" rel="bookmark" class="title">《高可用架构&CenterDot;中国初创故事（第3期）》一2&period;9　附加读物</a>
					<div>
						2.9 附加读物 管好团队做对事--软件企业成长手册 以下是一些与本章主题相关的附加读物. 1001 Ways to Reward Employees, by Bob Nelson (Workman  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkLvAz.html" rel="bookmark" class="title">iphone手机充电保养与省电技巧</a>
					<div>
						什么是完全充放电? iPhone的电池是锂电池,和过去手机的镍锌电池完全不一样.关于锂电池,有下面这些信息需要玩家掌握: 锂电池不管是&quot;完全充电&quot;或&quot;部分充电&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvXrmM.html" rel="bookmark" class="title">无线网络传输速度对比分析报告</a>
					<div>
						在选购一款无线路由器的时候,哪个参数是你最为关注的?相信绝大多数用户的答案都是无线传输速率. 没错,这个常常出现在产品外包装显著位置的数字,早已成为无线路由器的最重要的参数. 但你可了解,这个数字仅仅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N1yjz.html" rel="bookmark" class="title">关于多线程问题，求解答！</a>
					<div>
						问题描述 创建主线程Thread desktopServerThread = new Thread(new Server());  desktopServerThread.start();  publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8WLOb.html" rel="bookmark" class="title">按enter键进行搜索在android模拟器上要按两次确定才行</a>
					<div>
						问题描述 我的代码如下:$(function(){userName=sessionStorage.userName;$(&quot;#search&quot;).live(&quot;keydown& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA62lep.html" rel="bookmark" class="title">迭代器问题</a>
					<div>
						问题描述 为什么集合中循环访问元素时,一定要调用迭代器的remove()方法,而不能调用集合本身的remove()方法? 解决方案 如果调用集合本身的remove()方法,这时就改变了集合的size, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn4O3Kb.html" rel="bookmark" class="title">网络消费要理性 急用商品避开交易高峰</a>
					<div>
						通讯员 沈雁 韩志斌 记者 邬愉波 本周日,就是一年一度的&quot;双11&quot;网购狂欢节.除了创办这个网购节的天猫外,更多的购物网站也纷纷搭车推出各种名目繁多的促销.对于这个&quot;中国 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdmRAp.html" rel="bookmark" class="title">微软详细说明了用户在Word和Outlook中的前10个语法错误</a>
					<div>
						当用户在微软Word中打字,或在Outlook中写电子邮件时,毫无疑问他们会有时候会面临一些语法和拼写错误.现在,微软公布了了Outlook和Word中的前10大语法错误. 这份统计数据基于数百万订阅 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA6G32p.html" rel="bookmark" class="title">多家省级电视台长期播出涉嫌欺诈猜谜节目</a>
					<div>
						3月15日,河南省郑州市民王女士打开电视后非常高兴--因为令她郁闷了很久的电视&quot;有奖猜谜&quot;节目,在多家卫视台一下子都消失得无影无踪了. &quot;这个节目太骗人了!&quot;王 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.043 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
